" =============Plugins==================
call plug#begin()
Plug 'morhetz/gruvbox'
Plug 'tomtom/tcomment_vim'
Plug 'bling/vim-airline'
Plug 'vim-airline/vim-airline-themes'
Plug 'Shougo/deoplete.nvim', { 'do': ':UpdateRemotePlugins' }
Plug 'tpope/vim-fugitive'
Plug 'airblade/vim-gitgutter'
Plug 'Shougo/neosnippet.vim'
Plug 'honza/vim-snippets'
Plug 'vim-scripts/a.vim'
call plug#end()
" =============Settings==================
filetype plugin on
filetype indent on
set nocompatible
set ignorecase " Case sensitive off
set incsearch
set encoding=utf-8
set nobackup
set noswapfile
set mouse=a
set spelllang=en,de
set spellsuggest=double,10
set list
set icon
set listchars=tab:>.,trail:.,extends:#,nbsp:.
set showmatch " Show pair braces
set hlsearch "Highlight search
syntax on
set number
set scrolloff=2

if has("win32")
    " set rop=type:directx
    let g:loaded_matchparen = 1
end

" =================Look and feel=======================
colorscheme gruvbox

" =================Windows and Tabs====================
" Open a new tab with F2
map <F2> <Esc>:tabnew <CR><ESC>:Explore<CR>
imap <F2> <Esc>:tabnew <CR><ESC>:Explore<CR>
map <S-Right> :tabnext<CR>
map <S-Left> :tabprevious<CR>
nmap <silent> <A-Up> :wincmd k<CR>
nmap <silent> <A-Down> :wincmd j<CR>
nmap <silent> <A-Left> :wincmd h<CR>
nmap <silent> <A-Right> :wincmd l<CR>
" Open a new vertical split window with Ctrl - F2
map <C-F2> <Esc>:vsplit .<CR>
imap <C-F2> <Esc>:vsplit .<CR>
" Open a new horizontal split window with Shift - F2
map <S-F2> <Esc>:split .<CR>
imap <S-F2> <Esc>:split .<CR>

" =================save shortcut=======================
map <C-S> <ESC>:wa<CR>
imap <C-S> <ESC>:wa<CR>

" =================Comments============================
map <C-C> :TComment<CR>

" =================Python==============================
let g:python3_host_prog="f:\\Tools\\Python\\python.exe"
let g:python_host_prog="f:\\Tools\\Python27\\python.exe"

" =========================Deoplete====================
let g:deoplete#enable_at_startup = 1
" =========================neosnippet==================
" " Enable snipMate compatibility feature.
let g:neosnippet#enable_snipmate_compatibility = 1
" Tell Neosnippet about the other snippets
let g:neosnippet#snippets_directory='~/.vim/bundle/vim-snippets/snippets'
imap <expr><TAB> neosnippet#expandable_or_jumpable() ? "\<Plug>(neosnippet_expand_or_jump)" : pumvisible() ? "\<C-n>" : "\<TAB>" 
smap <expr><TAB> neosnippet#expandable_or_jumpable() ? "\<Plug>(neosnippet_expand_or_jump)" : "\<TAB>"
" =====================A======================
" Function for switching between header and c* files
map <F5> :wa <CR> :A<CR>
imap <F5> <Esc>:wa<CR>:A<CR>i
map <C-F5> :AV<CR>
imap <C-F5> <Esc>:AV<CR>i
map <S-F5> :AT<CR>
imap <S-F5> <Esc>:AT<CR>i
let g:alternateSearchPath = 'sfr:../source,sfr:../src,sfr:../include,../../include,sfr:../inc,sfr:../h'
" Dont create the file if the .cpp or .h is not found
let g:alternateNoDefaultAlternate = 1
